/******************************************************************************\
*  Copyright (C) 1995 Dallas Semiconductor Corporation.                        *
*  All rights Reserved. Printed in U.S.A.                                      *
*  This software is protected by copyright laws of                             *
*  the United States and of foreign countries.                                 *
*  This material may also be protected by patent laws of the United States     *
*  and of foreign countries.                                                   *
*  This software is furnished under a license agreement and/or a               *
*  nondisclosure agreement and may only be used or copied in accordance        *
*  with the terms of those agreements.                                         *
*  The mere transfer of this software does not imply any licenses              *
*  of trade secrets, proprietary technology, copyrights, patents,              *
*  trademarks, maskwork rights, or any other form of intellectual              *
*  property whatsoever. Dallas Semiconductor retains all ownership rights.     *
*                                                                              *
*  Compiler: Borland C++ 4.5  OWL                                              *
*  Ver 1.0                                                                     *
*  Date: 4/27/95                                                               *
*                                                                              *
\******************************************************************************/

//--------------------------Com Setup Dialog------------------------------------

class TComSetupDlg : public TDialog
{
   public:
      TComSetupDlg(TWindow* parent, int);
      void SetupWindow();
      void CloseWindow(int retValue = IDCANCEL);
   DECLARE_RESPONSE_TABLE(TComSetupDlg);
};

DEFINE_RESPONSE_TABLE1(TComSetupDlg, TDialog)
END_RESPONSE_TABLE;

TComSetupDlg::TComSetupDlg(TWindow* parent, int DlgResNum)
   : TDialog(parent, DlgResNum), TWindow(parent)
{

}
void TComSetupDlg::SetupWindow()
{
   
   if(comport == 1)                         //determine which comport is in use
      CheckRadioButton(101, 104, IDC_COM1);
   else if(comport == 2)
      CheckRadioButton(101, 104, IDC_COM2);
   else if(comport == 3)
      CheckRadioButton(101, 104, IDC_COM3);
   else
      CheckRadioButton(101, 104, IDC_COM4);
}
//==============================================================================
// CloseWindow
//==============================================================================
void TComSetupDlg::CloseWindow(int)
{
   if(IsDlgButtonChecked(101) == TRUE) //check to see if comport num was changed
      comport = 1;
   else if(IsDlgButtonChecked(102) == TRUE)
      comport = 2;
   else if(IsDlgButtonChecked(103) == TRUE)
      comport = 3;
   else if(IsDlgButtonChecked(104) == TRUE)
      comport = 4;
   TWindow::CloseWindow();
   handle = TMStartSession(comport); //start a new session
   TMSetup(comport);                 //perform setup
   
}

//-------------------------FileOpen Dialog Class for log file-------------------
class TComDlgWindow : public TFrameWindow
{
   public:
      TComDlgWindow(TWindow* parent, const char* title);

   DECLARE_RESPONSE_TABLE(TComDlgWindow);

};

DEFINE_RESPONSE_TABLE1(TComDlgWindow, TFrameWindow)
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TComDlgWindow::TComDlgWindow(TWindow* parent, const char* title)
   : TFrameWindow(parent, title), TWindow(parent, title)
{
   AssignMenu(1);
}

//-----------------------------TDialog Class for log setup----------------------
class TDlgDialog : public TDialog
{

   public:
      float time_interval;
      TDlgDialog(TWindow* parent, int);
      DECLARE_RESPONSE_TABLE(TDlgDialog);
      void SetupWindow();
      void CloseWindow(int retValue = IDCANCEL);
      void EvVScroll(UINT code, UINT pos, HWND wnd);
};
DEFINE_RESPONSE_TABLE1(TDlgDialog, TDialog)
   EV_WM_VSCROLL,
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TDlgDialog::TDlgDialog(TWindow* parent, int DlgResNum)
   :  TWindow(parent), TDialog(parent, DlgResNum)
{
   time_interval = (float)global_time_interval/ 100;
}

//==============================================================================
// SetupWindow
//==============================================================================
void TDlgDialog::SetupWindow()
{
   uchar buff[40];

   //determine which log proceedure is in use and check to approiate radiobutton
   if(!log_pass_flag)   
      CheckRadioButton(IDC_RADIOALLP, IDC_RADIOCHANGEDP, IDC_RADIOALLP);
   else if(log_pass_flag == 2)   
      CheckRadioButton(IDC_RADIOALLP, IDC_RADIOCHANGEDP, IDC_RADIOCHANGEDP);
   else
      CheckRadioButton(IDC_RADIOALLP, IDC_RADIOCHANGEDP, IDC_RADIOALARMP);

   //determine if saving to logfile or not--default is off
   if(strcmp(filen, "") == 0)
      CheckRadioButton(IDC_RADIOLOGON, IDC_RADIOLOGOFF, IDC_RADIOLOGOFF);
   else
      CheckRadioButton(IDC_RADIOLOGON, IDC_RADIOLOGOFF, IDC_RADIOLOGON);

   //determine if button present means device present or missing
   if(!switchflag)
      CheckRadioButton(IDC_DS2401OPEN, IDC_DS2401CLOSED, IDC_DS2401OPEN);
   else
      CheckRadioButton(IDC_DS2401OPEN, IDC_DS2401CLOSED, IDC_DS2401CLOSED);
      
   //translate the logging interval to ascii
   ftoa(((float)global_time_interval/100.0), (char *)buff, 2);

   //replace the . with a : to indicate time
   for(int i = 0; i < 4; i++)
   {
      if(buff[i] == '.')
         buff[i] = ':';
   }

   SetDlgItemText(DISPLAY_TIME_INTERVAL, (char *)buff);
}

//==============================================================================
// CloseWindow
//==============================================================================
void TDlgDialog::CloseWindow(int retValue)
{
   if(retValue == IDOK)
   {
      //check to see if logfile on radiobutton is checked
      int i = IsDlgButtonChecked(IDC_RADIOLOGON);
      if(i && strlen(filen) > 0)
      {
         log_file_open_flag = 2;
      }
      else if((i && strlen(filen) == 0) || IsDlgButtonChecked(IDC_RADIOCHANGE)) 
      {
         log_file_open_flag = 1;         //flag for file open dialog
      }
      else if(IsDlgButtonChecked(IDC_RADIOLOGOFF))
      {    
         log_file_open_flag = 0;
         strcpy(filen, "");
      }
      //determine which logging proceedure is in effect
      i = IsDlgButtonChecked(IDC_RADIOALLP);
      if((i != 0) && retValue == IDOK)
         log_pass_flag = 0;
      if(((i = IsDlgButtonChecked(IDC_RADIOCHANGEDP)) != 0) && retValue == IDOK)
         log_pass_flag = 2;
      if(((i = IsDlgButtonChecked(IDC_RADIOALARMP)) != 0) && retValue == IDOK)
         log_pass_flag = 1;

      //determine if device present means missing or present
      if(((i = IsDlgButtonChecked(IDC_DS2401OPEN)) != 0) && retValue == IDOK)
         switchflag = FALSE;
      else if(((i = IsDlgButtonChecked(IDC_DS2401CLOSED)) != 0) && retValue == IDOK)
         switchflag = TRUE;
      
      //setup the time interval for polling the system
      if(time_interval >= 1.00)
      {
         global_time_interval = 60;
         old_num_waits = num_waits = (uint) time_interval;
      }
      else
      {
         global_time_interval = (uint) (time_interval*100);
         num_waits = 0;
      }
   }
   TWindow::CloseWindow();
}

//==============================================================================
// EvVScroll:  handles scrolling of temperatures
//==============================================================================
void TDlgDialog::EvVScroll(UINT code, UINT, HWND)
{
   char buff[40];

   DestroyCaret();

   switch(code)
   {
      case 0:
         if(time_interval < MAXTIMEINTERVAL)
         {
            if(time_interval == 0.60)
            
               time_interval = 1.00;
            
            if(time_interval < .60)
            {

               time_interval = time_interval + 0.05;

              if((time_interval - 0.60) > 0.00 && (time_interval - 0.60) < 0.04)
                  time_interval = 1.00;
            }
            else
               time_interval = time_interval + 1.00;
         }
      break;
      case 1:
         if(time_interval > MINTIMEINTERVAL)
         {

            if((time_interval - 1.00) < 0.04 && (time_interval - 1.00) > - 0.04)
            
               time_interval = .60;
            
            if(time_interval < .65)

               time_interval -= 0.0500;

            else
               time_interval--;
         }
      break;
      default:
         break;
      }
      if(time_interval == 0.6)
         time_interval = 1.00;
     
      if(time_interval < .06)
         strcpy(buff, "0.00");
      else
         gcvt(time_interval, 4, buff);
      for(int i = 0; i < 10; i++)
         if(buff[i] == '.')
            buff[i] = ':';
      if(time_interval > .61)
         strcat(buff, ":00");
      else if(time_interval > .01)
      {
         if(strlen(buff) < 4)
            strcat(buff, "0");
      }

      SetDlgItemText(DISPLAY_TIME_INTERVAL, buff);

}

//---------------------------------TAboutDialog---------------------------------
class TAboutDialog : public TDialog
{
   public:
      TAboutDialog(TWindow* parent, int);
   DECLARE_RESPONSE_TABLE(TAboutDialog);
};
DEFINE_RESPONSE_TABLE1(TAboutDialog, TDialog)
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TAboutDialog::TAboutDialog(TWindow* parent, int DlgResNum)
   :  TWindow(parent), TDialog(parent, DlgResNum)
{

}

//==============================================================================
//         TDialog for Renaming devices on one wire port
//==============================================================================
class TRenameDlg : public TDialog
{
   public:
      TRenameDlg(TWindow* parent, int);
      void SetupWindow();
      void CloseWindow(int);
   DECLARE_RESPONSE_TABLE(TRenameDlg);
};

DEFINE_RESPONSE_TABLE1(TRenameDlg, TDialog)
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TRenameDlg::TRenameDlg(TWindow* parent, int DlgResNum) 
   :  TWindow(parent), TDialog(parent, DlgResNum)
{

}

//==============================================================================
// Setup Window
//==============================================================================
void TRenameDlg::SetupWindow()
{
   wsprintf(rom_buffer, "%2.2X %2.2X %2.2X %2.2X %2.2X %2.2X %2.2X %2.2X", rom[7], rom[6], rom[5], rom[4], rom[3], rom[2], rom[1], rom[0]);
   SetDlgItemText(ROM_ID, rom_buffer);
   Ren_ok_flag = FALSE;
} 
//==============================================================================
// CloseWindow
//==============================================================================
void TRenameDlg::CloseWindow(int retVal)
{
      if(retVal)
      {
         GetDlgItemText(NAME_EDIT, new_name, 24); 
         Ren_ok_flag = TRUE;
      }
      else
         Ren_ok_flag = FALSE;       
   
      TWindow::CloseWindow();
}

//==============================================================================
//Dialog to check to see if another device will be added
//==============================================================================
class TAddDlg : public TDialog
{
   public:
      TAddDlg(TWindow* parent, int);
      void SetupWindow();
      void CloseWindow(int DlgResNum);
   DECLARE_RESPONSE_TABLE(TAddDlg);
};
DEFINE_RESPONSE_TABLE1(TAddDlg, TDialog)
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TAddDlg::TAddDlg(TWindow* parent, int DlgResNum) 
   :  TWindow(parent), TDialog(parent, DlgResNum)
{

}

//==============================================================================
// Setup Window
//==============================================================================
void TAddDlg::SetupWindow()
{
   add_device = FALSE;
}

//==============================================================================
// Close window
//==============================================================================
void TAddDlg::CloseWindow(int retVal)
{
   if(retVal)
   {
      add_device = TRUE;
   }
   else
      add_device = FALSE;
   TWindow::CloseWindow();
}

//==============================================================================
// Previous settings dialog class
//==============================================================================
class TPreviousDlg : public TDialog
{
   public:
      TPreviousDlg(TWindow* parent, int);
      void CloseWindow(int);
   DECLARE_RESPONSE_TABLE(TPreviousDlg);
};
DEFINE_RESPONSE_TABLE1(TPreviousDlg, TDialog)
END_RESPONSE_TABLE;

//==============================================================================
// Constructor
//==============================================================================
TPreviousDlg::TPreviousDlg(TWindow* parent, int DlgResNum)
   : TWindow(parent), TDialog(parent, DlgResNum)
{

}

//==============================================================================
// CloseWindow
//==============================================================================
void TPreviousDlg::CloseWindow(int retVal)
{
   if(retVal)
      previous_flag = TRUE;
   else
      previous_flag = FALSE;
   
   TDialog::CloseWindow();
}

