/******************************************************************************\
*  Copyright (C) 1995 Dallas Semiconductor Corporation.                        *
*  All rights Reserved. Printed in U.S.A.                                      *
*  This software is protected by copyright laws of                             *
*  the United States and of foreign countries.                                 *
*  This material may also be protected by patent laws of the United States     *
*  and of foreign countries.                                                   *
*  This software is furnished under a license agreement and/or a               *
*  nondisclosure agreement and may only be used or copied in accordance        *
*  with the terms of those agreements.                                         *
*  The mere transfer of this software does not imply any licenses              *
*  of trade secrets, proprietary technology, copyrights, patents,              *
*  trademarks, maskwork rights, or any other form of intellectual              *
*  property whatsoever. Dallas Semiconductor retains all ownership rights.     *
*                                                                              *
*  Compiler: Borland C++ 4.5  OWL                                              *
*  Ver 1.0                                                                     *
*  Date: 4/27/95                                                               *
*                                                                              *
\******************************************************************************/
// ===========================================================
// The MDI child window class
// ===========================================================

class TDecoChild: public TMDIChild {
public:
   time_t timer;
   struct tm *tblock;   
   TDecoChild(TMDIClient& parent, const char far *name);
   void SetupWindow();
   void CloseWindow(int retVal) {::KillTimer(NULL, ID_MYTIMER); SaveFile(); TMDIChild::CloseWindow(retVal);};
   void ChangeName(const char far *name);
   int Unnamed() { return filename.length() == 0; }
   int SaveFile();// { return TRUE; }
   void EvTimer(UINT timerId);
   int handle;
   int numRows;
   string filename;
   
private:
 
   TListBox* listbox;
   TStatic*  title1;
   TStatic*  title2;
   TStatic*  time_text;
   TIArrayAsVector<string> sArray;
   int last_pass; // flag to indicate if network has changed since last pass;
   int last_szmissing;

   DECLARE_RESPONSE_TABLE(TDecoChild);
};

// Default constructor for File|New
DEFINE_RESPONSE_TABLE1(TDecoChild, TMDIChild)
   EV_WM_TIMER,
   
END_RESPONSE_TABLE;

// Alternate constructor for File|Open
TDecoChild::TDecoChild(TMDIClient& parent, const char far *name)
  : TMDIChild(parent, name), sArray(SARRAY_HIGH, SARRAY_LOW, SARRAY_DELTA)
{
   filename = name;
   Attr.Style |= MDIS_ALLCHILDSTYLES;
   Attr.Style &= ~WS_MAXIMIZEBOX;
   Attr.Style &= ~WS_MINIMIZEBOX;
   Attr.Style |=WS_MAXIMIZE;
   Attr.Style |= WS_VSCROLL;
//   Scroller = new TScroller(this, 0, 0, 0, 0);

   title1 = new TStatic(this, -1, "Name",50, 25, 50, 20);
   title2 = new TStatic(this, -1, "Status at", 250, 25, 60, 20);
   time_text = new TStatic(this, -1, "", 325, 25 , 250, 20);
   
   listbox = new TListBox(this, ID_TEMPLISTBOX, 50, 50, 420, 325);   
   listbox->Attr.Style |= LBS_MULTICOLUMN;
   listbox->Attr.Style &= ~WS_HSCROLL;
   
   numRows = 0;   
   num_waits = 0;
   last_szmissing = 0;
   last_pass = TRUE;

   TModule *TM;
   TM = GetModule();
   // timer for saving file every few minutes.  time controlled by a define statement;
   if(strcmp(name, "") != 0)
      ID_MYTIMER = ::SetTimer(NULL, 1, 30000, (TIMERPROC)MakeProcInstance((FARPROC)Save, TM->GetInstance())); 
   
}
// function used to setup autosave flag;
WORD FAR PASCAL Save(HWND, WORD, WORD, LONG)
{
   cp->SaveFile();
   return 0;
}
// save the log file;
int TDecoChild::SaveFile()
{
   char c[80];
   const char* cst;
   if(timecount == 0)
   {
      //check to make sure file needs to be saved.
      if(numRows)
      {
         FILE *fp;
         fp = fopen(filename.c_str(), "a+");
         for(int i = 0; i < numRows; i++)   
         {   
            cst = sArray[i]->c_str();
            strcpy(c, cst);
            int len;
            c[(len = strlen(c))] = 0x0a;
            c[len+1] = 0;
            fwrite(c, strlen(c), 1, fp);
         }
         sArray.Flush();
         numRows = 0;
         timecount = WAIT_TIME;
         fclose(fp);
      }
      else
         timecount = WAIT_TIME;
   }
   else
      --timecount;
   return TRUE;
}
void TDecoChild::EvTimer(UINT)
{
   char s[640];
   int i;
   int j;
   
   if(kill_timer_flag)
   {
      KillTimer(NULL);
      ::KillTimer(NULL, ID_MYTIMER);
      return;
   }
   
   if(num_waits == 0)
   {
   //   szmissing[0] = 0;
      if(Check_Tree())
      {
         //determine which logging procedure is in use.
         if((log_pass_flag == 2 && last_pass == TRUE) || log_pass_flag == 0)
         {
            timer = time(NULL);
            tblock = localtime(&timer);
            strcpy(s, asctime(tblock));
            s[strlen(s) - 1] = 0;
            time_text->SetText(s);
            sArray.Add(new string(s));
            numRows++;
                     
            last_pass = FALSE;
            for(i = 0; i < 40; i++)
            strcpy(device_array[i], "");
            listbox->ClearList();
            fill_array_with_info(root);
            for(i = 0; i < 40; i++)
               listbox->InsertString(device_array[i], i);   

            for(i = 0; i < num_devices; i++)
            {
               strcpy(s, device_array[i]);
               for(j = strlen(s); j < 25; j++)
                  s[j] = ' ';
               s[25] = 0;
               strcat(s, device_array[i+20]);
               sArray.Add(new string(s));
               numRows++;
            }
            strcpy(s, " ");
            sArray.Add(new string(s));
            numRows++;
            
            last_szmissing = szmissing = 0;
         }
         
      }
      else
      {
         //determing which logging procedure is in use;
         if(((log_pass_flag == 2) && (last_pass == FALSE || last_szmissing != szmissing)) || log_pass_flag == 1 || log_pass_flag == 0)
         {
            timer = time(NULL);
            tblock = localtime(&timer);
            strcpy(s, asctime(tblock));
            s[strlen(s) - 1] = 0;
            time_text->SetText(s);
            numRows++;
            sArray.Add(new string(s));
                     
            
            last_pass = TRUE;
            for( i = 0; i < 40; i++)
               strcpy(device_array[i], "");
            listbox->ClearList();
            fill_array_with_info(root);

            for(i = 0; i < 40; i++)
               listbox->InsertString(device_array[i], i);
            
            for(i = 0; i < num_devices; i++)
            {
               numRows++;
               strcpy(s, device_array[i]);
               for(int j = strlen(s); j < 25; j++)
                  s[j] = ' ';
               s[25] = 0;
               strcat(s, device_array[i+20]);
               sArray.Add(new string(s));
            }
            strcpy(s, " ");
            numRows++;
            sArray.Add(new string(s));
   
            last_szmissing = szmissing;
            szmissing = 0;
         }
         szmissing = 0;
      }
      num_waits = old_num_waits;
   }
   else
      num_waits--;
}

void TDecoChild::SetupWindow()
{
   int tab_pos[2] = {0 , 200};
   

   dc = new TClientDC(*this);
   TFrameWindow::SetupWindow();
   
  SetTimer(NULL, global_time_interval*1000);
  timer_set_flag = TRUE;
  listbox->SetColumnWidth(200);
  listbox->SetTabStops(2, tab_pos);
}

// Change window file name
void TDecoChild::ChangeName(const char far *name)
{
  filename = name;
  SetCaption(name);
}
