#include "exp5.rc"
#define DS1820 0x10
#define DS2405 0x05

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

uint global_time_interval = 10;
uint comport = 2, num_waits = 0, old_num_waits = 0;
TPoint location(0, 0);


uchar upper_cntl[16], lower_cntl[16], alarm_cntl[16], cntl_1993[16];
   
/***********************Function types from TMEX*******************************/
extern "C" 
{
	int   far pascal TMSetup(int);
	int	far pascal TMStartSession(int);
	int	far pascal TMEndSession(int);
	int	far pascal TMValidSession(int);
	//int 	far pascal TMFamilySearchSetup(int, uchar far *, int);
	int	far pascal TMNext(int, uchar far *);
	int	far pascal TMRom(int, uchar far *, int far *);
	int 	far pascal TMFirst(int, uchar far *);
	int   far pascal TMAccess(int, uchar far *);
	int   far pascal TMStrongAlarmAccess(int, uchar far *);
   int   far pascal TMTouchByte(int, int);
	int 	far pascal TMTouchReset(int);
	int   far pascal TMFirstAlarm(int, uchar far *);
	int   far pascal TMNextAlarm(int, uchar far *);
   int   far pascal TMWritePacket(int, uchar far *, int, uchar far *, int);
}

//==============================================================================
// function declarations
//==============================================================================
struct tnode far *talloc(void);
struct tnode *addtree(struct tnode far *, int rom1[8]);
int agetree(struct tnode *);
int Check_Tree();
struct tnode *search_tree(struct tnode *p, int rom1[8]);
struct tnode *search_tree_string(struct tnode *p, char *pstring);
char *strdup1(char *s);
int agetreenull(struct tnode *p);
int set_temp_parameters(struct tnode *p);
int alarm_search();
void copy_names(struct tnode *p);
void save_setup(struct tnode *p);
void read_settings(void);
int check_1993(void);

uchar exit1;
int out_stream;
int in_stream;

// memory model functions that will work with Large Memory Model.
void mstrcpy(char far *dest, char far *src);
void mmemcpy(uchar far *dest, uchar far *src, uchar transnum);
int mmemcmp(uchar far *ml, uchar far *m2, int n);
void SwitchOff(uchar far *RI);
void SwitchOn(uchar far *RI);
uchar SwitchState(uchar far *RI);
static void wait_counts(ulong wait_count);

//==============================================================================
// global variable declarations
//==============================================================================
char filen[80];
char rom_buffer[40];
TClientDC *dc;
int handle;    // handle for TMEX
uchar GB[2048]; // garbage bag array for TMEX
int Ren_ok_flag;
int add_device;                                                   
int rom[8];
char new_name[25];
int age_flag;
int already_loging = FALSE;
int kill_timer_flag = FALSE;

int log_pass_flag = 3; // 0 = log all passes, 1 = log alarming passes, 2 = log changed passes

struct tnode
{
	char word[25];
	int ROMID[8];
	int ageflag;
	int count;
	char temperature[20];
	int maxtemp;
	int mintemp;
	int set_alarm;
	int alarming;
	struct tnode *left;
	struct tnode *right;
};



struct tnode far *root;
struct tnode far *found_string;

struct name_list
{
	char name[20][50];
	int romid[8];
	int length;
};
struct name_list far *names;


int alarm_on = FALSE;
int currentRows = 0;
class TDecoChild;
TDecoChild *cp;
WORD FAR PASCAL Save(HWND, WORD, WORD, LONG);
UINT ID_MYTIMER;
UINT ID_EVTIMER;
WORD FAR PASCAL Temperature(HWND, WORD, WORD, LONG);
UINT ID_TEMPTIMER;
int timecount = WAIT_TIME; //set for the amount of time between autosaves;
char szmissing[500];
char sz[50];
char alarming_devices[500];
int timer_set_flag = FALSE;
int switchflag = FALSE;
int finished_flag = TRUE;
int fahrenheit = TRUE;    //determines weather fahrenheit or celsius(*F default)
int lower_alarm_temp = 0; //default lower temperature for alarm
int upper_alarm_temp = 22; //default for upper temperature
int flag_celsius = FALSE;  
int alarm_flag = FALSE;
int changing_temp = FALSE;
int num_devices = 0;
int first_time = FALSE;
int previous_flag = FALSE;
int add = FALSE;
int not_upper = FALSE;
//int temp_rom[8];
uchar temp_rom[16];
uchar log_file_open_flag;
uchar alarm_enable = FALSE; //alarm is off for begin program

TButtonGadget *AlarmGadget;
uchar data_1993[600];
int k1 = 0;
